;AST week4 msu1 spc replacement patch by Conn



header
lorom

org $A886D9
db $ff

org $A888F9
db $ff

org $808174
JSL newTrack
NOP
NOP

org $808158
JSL msuBusy
NOP


org $C1F1A2
jsl t10
nop

org $C7F190
jsl t11
nop

org $cff29b
jsl tmute
nop

org $d5f1a2
jsl t5
nop

org $e3f1a2
jsl t15
nop

org $E5F1A2
jsl t9
nop

org $a882a6
jsl tf
nop

org $A48378
jsl tb
nop

org $EDF1A2
jsl t21
nop



org $FBF300
newTrack:
STA $0133
PHA
LDA $2002      ;check if msu found 
CMP #$53    
BEQ msuFound
PLA
STA $2140
RTL
msuFound:
LDA #$01
STA $0129  ; set msu busy
PLA 
CMP #$02
BNE c1
LDA $7fffff
cmp #$38
beq $04
lda #$02
bra $02
lda #$f1
c1:
STA $0127  ;store track number
PHA
AND #$F0
CMP #$F0
BEQ endTrack
PLA
STA $2004
STZ $2005
STZ $2006
PHA
LDA #$F1
STA $2140
PLA
RTL
endTrack:
LDA #$F1
STA $2140
PLA
RTL

msuBusy:
SEP #$30
LDA $4210
LDA $0129
BNE $01
end:
RTL
LDA $0127
cmp #$f1
beq f1
cmp #$f2
beq f2
cmp #$f3
beq f3
bit $2000
bvs end    ; track not ready
STZ $0129  ; clear msu busy flag
LDA $0127
tax
lda $FBF500,x ;load loop value
sta $2007  
lda #$FF   ; lautstrke
sta $2006
sta $012b ; fade
bra end
f1:
lda $012b
dec
dec
dec
cmp #$10
bcs $05
lda #$00
sta $0129
sta $2006
sta $012b
bra end
f2:
lda $012b
dec
dec
dec
cmp #$60
bcs $03
stz $0129
sta $012b
sta $2006
bra end
f3:
lda $012b
inc
inc
inc
cmp #$fb
bcc $05
stz $0129
lda #$FF
sta $2006
sta $012b
bra end

t10:
lda #$10
jmp continue
t11:
lda #$11
jmp continue
t5:
lda #$05
jmp continue
t9:
lda #$09
jmp continue
tb:
lda #$0b
jmp continue
t15:
lda #$15
jmp continue
tf:
lda #$0f
jmp continue
t21:
lda #$21
jmp continue
continue:
pha
LDA $2002      ;check if msu found 
CMP #$53    
BEQ $05
PLA
STA $2140
RTL
PLA
PHX
PHP
SEP #$30
STA $2004
STZ $2005
loop:
bit $2000
bvs loop    ; track not ready
tax
lda $FBF500,x ;load loop value
sta $2007  
lda #$FF   ; lautstrke
sta $2006
PLP
PLX
RTL

tmute:
LDA #$F1
STA $2140
LDA $2002      ;check if msu found 
CMP #$53    
BNE $03
STZ $2007
RTL

ORG $FBF500 ; loop table 03:loop, 01 non-loop
db $03,$01,$03,$03,$03,$03,$03,$03,$01,$03,$01,$03,$03,$03,$03,$01 ; themes 00-0f
db $03,$03,$03,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$03,$03 ; themes 10-1f
db $03,$01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 20-2f
